--Mailbox Functions for Abigail 2.30
--17/12/13

local abiTempHowMany=0
local abiMailDelay=0
local abiTotalCash=0
local abiWhichButton=0
local abiMailNumItems=0
local index=0
local abiAttachedCash=0
local abiFoundTable={}


function abiMailButtonClicked(passed)
	abiWhichButton=passed
	abiMailNumItems,_=GetInboxNumItems()
	index=abiMailNumItems
	abiMailTakeCash:Disable()
	abiMailTakeSuccess:Disable()
	abiMailTakeFailed:Disable()
	abiMailTakeOthers:Disable()
	abiFillTheFoundTable(abiMailNumItems,abiWhichButton)
	abiMailDelay=0 -- just make sure its reset
	abiMailExtraFrame:SetScript("OnUpdate",abiMailUpdate)
end



function abiMailUpdate(frame,arg1)
	abiMailDelay=abiMailDelay+arg1
	if abiMailDelay<0.5 then
		return
	end

	abiMailDelay=0

	if #abiFoundTable==0 then
		abiMailExtraFrame:SetScript("OnUpdate",nil)
		abiMailTakeCash:Enable()
		abiMailTakeSuccess:Enable()
		abiMailTakeFailed:Enable()
		abiMailTakeOthers:Enable()
		abiTotalCash=0
		abiGetFreeSlotsNeeded()
		return
	end

	index=abiFoundTable[#abiFoundTable]

	abiRealm=GetRealmName()..abiMyFaction
	local t1,t2,t3,t4,t5,t6,t7,abiRatio,t8,t10,t11,t9
	local Rat1,Rat2
	local abiBid,abiBuyout,abiAmount,abiVendorPrice,abiDeposit,abiConsignment

	_,_,_,abiSubject,abiAttachedCash,_,_,abiTempHowMany,abiWasRead=GetInboxHeaderInfo(index)
	abiItemName,_,abiCount=GetInboxItem(index)


	-- first check if its cash

	if abiWhichButton==1 and abiWasRead==nil then 
		_,abiItemName,_,abiBid,abiBuyout,abiDeposit,abiConsignment=GetInboxInvoiceInfo(index)

		_,abiItemLink=GetItemInfo(abiItemName)
		if abiItemName=="Pet Cage" then
			abiItemName=string.sub(abiSubject,21)
			abiItemLink=abiNilLink
		end

		if abiItemLink==nil then
			abiItemLink=abiNilLink
		end

		if abiBuyout==0 or abiBid<abiBuyout then
			abiAmount=abiBid 
		else
			abiAmount=abiBuyout
		end

		abiTotalCash=abiTotalCash-(abiAmount-abiConsignment+abiDeposit)
		abiPLV[abiRealm][1]=abiPLV[abiRealm][1]+abiAmount-abiConsignment+abiDeposit

		-- get the amount / stack size
		abiAmount=math.floor(abiAmount/abiCalculateStackSize(abiSubject))

		if abiAmount<1 then
			abiAmount=1
		end

		abiVendorPrice=math.floor(abiAmount/2)

		if abiVendorPrice<1 then
			abiVendorPrice=1
		end

		if abiPriceIndex[abiRealm][abiItemName]~=nil then

			t1,t2,t3,abiShigh1,abiSlow1,abiRsold1,t7,abiRatio1,t8,abiTimeStamp,t10,t11,t9=abiDecodeIndex(abiPriceIndex[abiRealm][abiItemName])

			Rat1,Rat2=abiDecodeRatio(abiRatio1)
			Rat1=Rat1+1
			Rat2=Rat2+1

			-- this next bit needed incase of a successful sell of an item we have not recorded as been auctioned
			if Rat1>Rat2 then
				Rat2=Rat1
			end

			if abiAmount>abiShigh1 then
				abiShigh1=abiAmount
			end

			if abiAmount<abiSlow1 or abiSlow1==0 then
				abiSlow1=abiAmount
			end

			abiRsold1=tostring(abiAmount)..":"..tostring(time())
			abiRatio1=tostring(Rat1)..":"..tostring(Rat2)
			abiPriceIndex[abiRealm][abiItemName]=t1.."%"..t2.."%"..t3.."%"..abiShigh1.."%"..abiSlow1.."%"..abiRsold1.."%"..t7.."%"..abiRatio1.."%"..t8.."%"..abiTimeStamp.."%"..t10.."%"..t11.."%x%"..t9
		else
			abiPriceIndex[abiRealm][abiItemName]=abiItemLink.."%0%0%"..abiAmount.."%"..abiAmount.."%"..abiAmount..":"..time().."%0:0%1:1%0:0%"..time().."%0:0%0:0%x%"..abiMakeFullPrice(abiVendorPrice).."*1"
		end

		if abiCurrentAuctions[abiItemName]~=nil then

			t1,t2,t3,abiShigh1,abiSlow1,abiRsold1,t7,abiRatio1,t8,_,t10,t11,t9=abiDecodeIndex(abiCurrentAuctions[abiItemName])

			Rat1,Rat2=abiDecodeRatio(abiRatio1)
			Rat1=Rat1+1
			Rat2=Rat2+1

			-- this next bit needed incase of a successful sell of an item we have not recorded as been auctioned
			if Rat1>Rat2 then
				Rat2=Rat1
			end

			if abiAmount>abiShigh1 then
				abiShigh1=abiAmount
			end

			if abiAmount<abiSlow1 or abiSlow1==0 then
				abiSlow1=abiAmount
			end

			abiRsold1=tostring(abiAmount)..":"..tostring(time())
			abiRatio1=tostring(Rat1)..":"..tostring(Rat2)
			abiCurrentAuctions[abiItemName]=t1.."%"..t2.."%"..t3.."%"..abiShigh1.."%"..abiSlow1.."%"..abiRsold1.."%"..t7.."%"..abiRatio1.."%"..t8.."%0%"..t10.."%"..t11.."%x%"..t9
		else
			abiCurrentAuctions[abiItemName]=abiItemLink.."%0%0%"..abiAmount.."%"..abiAmount.."%"..abiAmount..":"..time().."%0:0%1:1%0:0%0%0:0%0:0%x%"..abiMakeFullPrice(abiVendorPrice).."*1"
		end

		local bodyText, texture, isTakeable, isInvoice = GetInboxText(index)
		--this sets the item as being read

	end

	if abiWhichButton==1 then
		-- actually take the cash from the Mailbox
		AutoLootMailItem(index)
		AbigailMoneyFrame_Update("abiMailMoneyFrame1",abiTotalCash,0,"|cffffffff")
		table.remove(abiFoundTable,#abiFoundTable)
		return
	end



	-- Now check if it is a won auction

	if abiWasRead==nil and abiWhichButton==2 then

		_,abiItemName,_,abiBid,abiBuyout=GetInboxInvoiceInfo(index)
		abiItemLink=nil

		if abiItemName=="Pet Cage" then
			abiItemName=string.sub(abiSubject,14)
		else
			abiItemLink=GetInboxItemLink(index)
		end

		if abiItemLink==nil then
			abiItemLink=abiNilLink
		end

		if abiBuyout==0 or abiBid<abiBuyout then
			abiAmount=abiBid
		else
			abiAmount=abiBuyout
		end

		-- add amount spent to [27]
		abiPLV[abiRealm][2]=abiPLV[abiRealm][2]+abiAmount

		-- get the amount / stack size
		abiAmount=math.floor(abiAmount/abiCalculateStackSize(abiSubject))

		if abiAmount<1 then
			abiAmount=1
		end

		if abiPriceIndex[abiRealm][abiItemName]~=nil then
			t1,abiBhigh1,abiBlow1,t4,t5,t6,t7,abiRatio1,t8,abiTimeStamp,t10,t11,t9=abiDecodeIndex(abiPriceIndex[abiRealm][abiItemName])

			if abiBhigh1<abiAmount then
				abiBhigh1=abiAmount
			end

			if abiBlow1>abiAmount or abiBlow1==0 then
				abiBlow1=abiAmount
			end

			t7=tostring(abiAmount)..":"..tostring(time())
				abiPriceIndex[abiRealm][abiItemName]=t1.."%"..abiBhigh1.."%"..abiBlow1.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..abiRatio1.."%"..t8.."%"..abiTimeStamp.."%"..t10.."%"..t11.."%x%"..t9
		else
				abiPriceIndex[abiRealm][abiItemName]=abiItemLink.."%"..abiAmount.."%"..abiAmount.."%0%0%0:0%"..abiAmount..":"..time().."%0:0%0:0%"..time().."%0:0%0:0%x%"..abiMakeFullPrice(abiAmount).."*1"
		end

		if abiCurrentAuctions[abiItemName]~=nil then
			t1,abiBhigh1,abiBlow1,t4,t5,t6,t7,abiRatio1,t8,_,t10,t11,t9=abiDecodeIndex(abiCurrentAuctions[abiItemName])

			if abiBhigh1<abiAmount then
				abiBhigh1=abiAmount
			end

			if abiBlow1>abiAmount or abiBlow1==0 then
				abiBlow1=abiAmount
			end

			t7=tostring(abiAmount)..":"..tostring(time())
				abiCurrentAuctions[abiItemName]=t1.."%"..abiBhigh1.."%"..abiBlow1.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..abiRatio1.."%"..t8.."%0%"..t10.."%"..t11.."%x%"..t9
		else
				abiCurrentAuctions[abiItemName]=abiItemLink.."%"..abiAmount.."%"..abiAmount.."%0%0%0:0%"..abiAmount..":"..time().."%0:0%0:0%0%0:0%0:0%x%"..abiMakeFullPrice(abiAmount).."*1"
		end

		local bodyText, texture, isTakeable, isInvoice = GetInboxText(index)
		--this sets the item as being read

	end

	if abiWhichButton==2 then
		-- actually take the item from the Mailbox
		AutoLootMailItem(index)
		table.remove(abiFoundTable,#abiFoundTable)
		return
	end



	-- now check if a returned item that did not sell

	if abiWasRead==nil and abiWhichButton==3 then

		abiItemName=GetInboxItem(index)
		abiItemLink=GetInboxItemLink(index)

		_,_,_,_,_,_,_,_,_,_,abiVendorPrice=GetItemInfo(abiItemLink)

		if abiVendorPrice==nil then
			abiVendorPrice=1
		end

		if abiVendorPrice==0 then
			abiVendorPrice=1
		end

		if abiItemLink==nil then
			abiItemLink=abiNilLink
		end

		if abiDecodeItemLink(abiItemLink)=="Pet Cage" then
			abiItemLink=abiNilLink
		end

		if abiPriceIndex[abiRealm][abiItemName]~=nil then
			t1,t2,t3,t4,t5,t6,t7,abiRatio,t8,abiTimeStamp,t10,t11,t9=abiDecodeIndex(abiPriceIndex[abiRealm][abiItemName])
			Rat1,Rat2=abiDecodeRatio(abiRatio)
			Rat2=Rat2+1
			abiRatio=tostring(Rat1)..":"..tostring(Rat2)

			if t1==abiNilLink then
				t1=abiItemLink
			end

			abiPriceIndex[abiRealm][abiItemName]=t1.."%"..t2.."%"..t3.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..abiRatio.."%"..t8.."%"..abiTimeStamp.."%"..t10.."%"..t11.."%x%"..t9
		else
			abiPriceIndex[abiRealm][abiItemName]=abiItemLink.."%0%0%0%0%0:0%0:0%0:1%0:0%"..time().."%0:0%0:0%x%"..abiMakeFullPrice(abiVendorPrice).."*1"
		end

		if abiCurrentAuctions[abiItemName]~=nil then
			t1,t2,t3,t4,t5,t6,t7,abiRatio,t8,_,t10,t11,t9=abiDecodeIndex(abiCurrentAuctions[abiItemName])
			Rat1,Rat2=abiDecodeRatio(abiRatio)
			Rat2=Rat2+1
			abiRatio=tostring(Rat1)..":"..tostring(Rat2)

			if t1==abiNilLink then
				t1=abiItemLink
			end

			abiCurrentAuctions[abiItemName]=t1.."%"..t2.."%"..t3.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..abiRatio.."%"..t8.."%0%"..t10.."%"..t11.."%x%"..t9
		else
			abiCurrentAuctions[abiItemName]=abiItemLink.."%0%0%0%0%0:0%0:0%0:1%0:0%0%0:0%0:0%x%"..abiMakeFullPrice(abiVendorPrice).."*1"
		end

		local bodyText, texture, isTakeable, isInvoice = GetInboxText(index)
		--this sets the item as being read
	end

	if abiWhichButton==3 then

		-- actually take the item from the Mailbox
		AutoLootMailItem(index)
		table.remove(abiFoundTable,#abiFoundTable)
		return
	end



	-- now check for any other type of item

	if abiWhichButton==4 then

		-- get any attached money first
		if abiAttachedCash~=0 then
			TakeInboxMoney(index)
			-- next bit removes from table if mail is only cash ie from another player
			if abiTempHowMany==nil then
				table.remove(abiFoundTable,#abiFoundTable)
			end
			return
		end

		local bodyText, texture, isTakeable, isInvoice = GetInboxText(index)

		--this sets the item as being read

		-- actually take the item from the Mailbox
		if abiTempHowMany==1 then
			TakeInboxItem(index)
			table.remove(abiFoundTable,#abiFoundTable)
		else
			TakeInboxItem(index,abiTempHowMany)
		end

	end

end



function abiMailExtraFrame_OnLoad()
	framename="abiMailMoneyFrame1"
	f=CreateFrame("Frame",framename,abiMailExtraFrame,"AbigailMoneyFrameTemplate")
	f:SetPoint("TOPLEFT",abiMailExtraFrame,"TOPLEFT",227,-40)
	AbigailMoneyFrame_Update("abiMailMoneyFrame1",0,0,"|cffffffff")
	hooksecurefunc("MailFrameTab_OnClick",abiMailTab_OnClick)
	abiGetFreeSlotsNeeded()
	abiGetBagNames()
	-- register for event Bag_Update
	-- when it fires, get the bag names, slots and slots needed values
	abiMailExtraFrame:RegisterEvent("BAG_UPDATE")
	abiMailExtraFrame:RegisterEvent("MAIL_INBOX_UPDATE")
end



function abiMailExtraFrame_OnEvent(frame,event,...)
	if event=="BAG_UPDATE" or event=="MAIL_INBOX_UPDATE" then
		abiGetFreeSlotsNeeded()
		abiGetBagNames()
	end
end




function abiMailTab_OnClick(self,index)
	if index==1 then
		abiMailExtraFrame:Show()
	else
		abiMailExtraFrame:Hide()
	end
end



function abiGetFreeSlots()
	return GetContainerNumFreeSlots(0),GetContainerNumFreeSlots(1),GetContainerNumFreeSlots(2),GetContainerNumFreeSlots(3),GetContainerNumFreeSlots(4)
end



function abiGetBagNames()
	local n0,n1,n2,n3,n4=0
	local f0,f1,f2,f3,f4=0
	n0=GetBagName(0) or "Unused"
	n1=GetBagName(1) or "Unused" 
	n2=GetBagName(2) or "Unused"
	n3=GetBagName(3) or "Unused"
	n4=GetBagName(4) or "Unused"

	abiBagString0:SetText("|cffffffff1 : "..n0)
	abiBagString1:SetText("|cffffffff2 : "..n1)
	abiBagString2:SetText("|cffffffff3 : "..n2)
	abiBagString3:SetText("|cffffffff4 : "..n3)
	abiBagString4:SetText("|cffffffff5 : "..n4)

	f0,f1,f2,f3,f4=abiGetFreeSlots()
	abiBagSlots0:SetText("|cffffffff"..f0.." / "..GetContainerNumSlots(0))
	abiBagSlots1:SetText("|cffffffff"..f1.." / "..GetContainerNumSlots(1))
	abiBagSlots2:SetText("|cffffffff"..f2.." / "..GetContainerNumSlots(2))
	abiBagSlots3:SetText("|cffffffff"..f3.." / "..GetContainerNumSlots(3))
	abiBagSlots4:SetText("|cffffffff"..f4.." / "..GetContainerNumSlots(4))
	abiFreeSlots:SetText("|cffffffff"..f0+f1+f2+f3+f4)
end



function abiGetFreeSlotsNeeded()
	local abiCashFound=0
	local abiPurchasedSlots=0
	local abiFailedSlots=0
	local abiElseSlots=0
	local n,t=GetInboxNumItems()
	local abiFound=0

	for index=1,n do
		abiFound=0
		abiAmount=0
		_,_,_,abiSubject,abiMoney,_,_,abiCount,abiWasRead=GetInboxHeaderInfo(index)
		if abiMoney==nil then
			abiMoney=0
		end
		if abiCount==nil then
			abiCount=0
		end

		if string.sub(abiSubject,1,18)=="Auction successful" then
			abiFound=1

			_,abiItemName,_,abiBid,abiBuyout,abiDeposit,abiConsignment=GetInboxInvoiceInfo(index)

			if abiBuyout==0 or abiBid<abiBuyout then
				abiAmount=abiBid
			else
				abiAmount=abiBuyout
			end

			abiAmount=abiAmount+abiDeposit-abiConsignment

			abiCashFound=abiCashFound+abiAmount
		end

		if string.sub(abiSubject,1,11)=="Auction won" then
			abiFound=1
			abiPurchasedSlots=abiPurchasedSlots+1
		end

		if string.sub(abiSubject,1,15)=="Auction expired" then
			abiFound=1
			abiFailedSlots=abiFailedSlots+1
		end

		if abiFound==0 then
			abiElseSlots=abiElseSlots+abiCount
		end

	end

	abiPurchaseString:SetText("|cffffffffSlots Needed : "..abiPurchasedSlots)
	abiFailedString:SetText("|cffffffffSlots Needed : "..abiFailedSlots)
	abiElseString:SetText("|cffffffffSlots Needed : "..abiElseSlots)

	AbigailMoneyFrame_Update("abiMailMoneyFrame1",abiCashFound,0,"|cffffffff")
	abiTotalCash=abiCashFound
end




function abiFillTheFoundTable(abiNum,abiButton)
	abiFoundTable=table.wipe(abiFoundTable)
	for abiloop=1,abiNum do
		_,_,_,abiSubject,_,_,_,_,abiWasRead=GetInboxHeaderInfo(abiloop)

		if string.sub(abiSubject,1,18)=="Auction successful" and abiButton==1 then
			abiFoundTable[#abiFoundTable+1]=abiloop
		end

		if string.sub(abiSubject,1,11)=="Auction won" and abiButton==2 then
			abiFoundTable[#abiFoundTable+1]=abiloop
		end

		if string.sub(abiSubject,1,15)=="Auction expired" and abiButton==3 then
			abiFoundTable[#abiFoundTable+1]=abiloop
		end

		if string.sub(abiSubject,1,15)~="Auction expired" and string.sub(abiSubject,1,18)~="Auction successful" and string.sub(abiSubject,1,11)~="Auction won" and abiButton==4 then
			abiFoundTable[#abiFoundTable+1]=abiloop
		end

	end
end